/* SCCS @(#)BPUpdate.mod	1.1---02/23/00--13:19:17 */

/* Copyright 1999 University of Southern California Brain Lab */
/* email nsl@java.usc.edu */

nslImport nslAllImports;

nslModule BPUpdate (int inSize, int hidSize, int outSize) {

    public NslDinFloat1 deltaOut(outSize);
    public NslDinFloat1 p(inSize);
    public NslDinFloat1 yh(hidSize);

    private NslFloat1 deltaHid(hidSize);     
    private NslFloat0 lrate();

    public NslDinFloat2 whi(inSize, hidSize);
    public NslDinFloat1 hhi(hidSize);

    public NslDinFloat2 woi(hidSize, outSize);
    public NslDinFloat1 hoi(outSize);

    public NslDinFloat2 wh(inSize, hidSize);
    public NslDinFloat1 hh(hidSize);

    public NslDoutFloat2 wo(hidSize, outSize);
    public NslDoutFloat1 ho(outSize);

    public void backward() {	
	deltaHid = nslElemMult(yh ^ ((float)1.0 - yh), nslProd(deltaOut,nslTrans(woi)));
	ho = hoi - (lrate ^ deltaOut); 
        wo = woi - nslProd(nslTrans(yh),(lrate ^ deltaOut)); 
	hh = hhi - (lrate ^ deltaHid); 
        wh = whi - nslProd(nslTrans(p),nslElemMult(lrate, deltaHid)); 
    }

    public void simTrain() {
        backward ();
    }

}


