/* SCCS @(#)BackPropModel.mod	1.1---02/23/00--13:19:17 */

/* Copyright 1999 University of Southern California Brain Lab */
/* email nsl@java.usc.edu */

nslImport nslAllImports;

nslImport TrainManager;
nslImport BPForward;
nslImport BPError;
nslImport BPUpdate;
nslImport BPDisplayResult;

nslModel BackPropModel () {

    int inSize  = 2;
    int hidSize = 2;
    int outSize = 1;
    int nPats   = 4;
        
    public TrainManager train(nPats,inSize,outSize);
    public BPForward    forward(inSize,hidSize,outSize);
    public BPError      error(outSize);
    public BPUpdate     update(inSize,hidSize,outSize);

    public BPDisplayResult result(inSize, outSize);

    public NslDoutFloat2 wh(inSize, hidSize);
    public NslDoutFloat1 hh(hidSize);

    public NslDoutFloat2 wo(hidSize, outSize);
    public NslDoutFloat1 ho(outSize);

    public void initSys() {
    	system.setNumTrainEpochs(1000);
	system.setTrainEndTime(nPats);
	system.setRunEndTime(1);
    }

    public void initModule() {
	system.nslSetTrainDelta(1);     
	system.nslSetRunDelta(1);
    }

    public void initTrainEpoch() {
        wh = nslRandom(wh,(float)-0.5,(float)0.5);
        hh = nslRandom(hh,(float)-0.5,(float)0.5);

        wo = nslRandom(wo,(float)-0.5,(float)0.5);
        ho = nslRandom(ho,(float)-0.5,(float)0.5);
    }   
     
    public void makeConn() {
	nslConnect(train.p,forward.p);
	nslConnect(train.t,error.t);

        nslConnect(this.wh, forward.wh);
        nslConnect(this.hh, forward.hh);
        nslConnect(this.wo, forward.wo);
        nslConnect(this.ho, forward.ho);

	nslConnect(forward.yo, error.yo);
	nslConnect(error.err,  update.deltaOut);
	nslConnect(forward.yh, update.yh);
	nslRelabel(forward.p,  update.p);

        nslRelabel(this.wh, update.wh);
        nslRelabel(this.hh, update.hh);
        nslRelabel(this.wo, update.wo);
        nslRelabel(this.ho, update.ho);

        nslConnect(this.wh, update.whi);
        nslConnect(this.hh, update.hhi);
        nslConnect(this.wo, update.woi);
        nslConnect(this.ho, update.hoi);
    }
}



